=== debian/changelog ===
seastar (25.05.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1109143)

 -- Asias He <asias@debian.org>  Sat, 12 Jul 2025 07:37:06 +0000
