=== debian/control ===
Source: seastar
Section: libs
Priority: optional
Maintainer: Asias He <asias@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 diffutils (>= 3.10),
 cmake (>= 3.31.6),
 doxygen,
 g++ (>= 14),
 gcc (>= 10),
 libboost-all-dev,
 libc-ares-dev,
 libcrypto++-dev,
 libfmt-dev,
 libgnutls28-dev,
 libhwloc-dev,
 liblz4-dev,
 libnuma-dev,
 libpciaccess-dev,
 libprotobuf-dev,
 libsctp-dev,
 libtool,
 liburing-dev,
 libxml2-dev,
 libyaml-cpp-dev,
 make (>= 4.4.1),
 meson,
 ninja-build,
 openssl,
 pkgconf,
 protobuf-compiler,
 python3,
 python3-pyelftools,
 python3-yaml,
 ragel,
 stow,
 systemtap-sdt-dev,
 valgrind,
 xfslibs-dev
Standards-Version: 4.7.2
Homepage: https://github.com/scylladb/seastar
Rules-Requires-Root: no

Package: seastar-dev
Section: libdevel
Architecture: amd64
Multi-Arch: same
Depends: ${misc:Depends}
Description: high-performance C++ framework for server applications
 Seastar is a high-performance event-driven framework designed for
 building scalable server applications. It provides a shared-nothing
 architecture and supports asynchronous programming with futures.
 .
 This package contains the development files and headers necessary
 for building applications using the Seastar framework.
