=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_test:
	# skip tests
	:

override_dh_auto_configure:
	dh_auto_configure -- -DSeastar_TESTING=OFF -DSeastar_APPS=OFF -DSeastar_DEMOS=OFF -DSeastar_DOCS=OFF -DSeastar_DPDK=OFF

override_dh_install:
	dh_install
	rm -f debian/seastar-dev/usr/bin/seastar-json2code.py
